#ifndef MSP_IO_PIPE_H_
#define MSP_IO_PIPE_H_

#include "eventobject.h"
#include "eventreader.h"
#include "handle.h"

namespace Msp {
namespace IO {

class Pipe: public EventObject
{
private:
	Handle handle[2];
	EventReader reader;

public:
	Pipe();
	~Pipe();

	void set_block(bool);

protected:
	virtual unsigned do_write(const char *, unsigned);
	virtual unsigned do_read(char *, unsigned);

public:
	virtual const Handle &get_event_handle() { return reader.get_event(); }
};

} // namespace IO
} // namespace Msp

#endif
